def rect_collides_with_circle(rect, circle_center, circle_radius):
    cx, cy = circle_center

    closest_x = max(rect.left, min(cx, rect.right))
    closest_y = max(rect.top, min(cy, rect.bottom))

    dx = cx - closest_x
    dy = cy - closest_y

    return (dx * dx + dy * dy) <= (circle_radius * circle_radius)


import math

def circle_collides_with_circle(x1, y1, r1, x2, y2, r2):
    """Check if two circles collide."""
    return math.hypot(x2 - x1, y2 - y1) <= (r1 + r2)
